(function (window, undefined) {
    if (window.Promise) return;
// resolve 和 reject 最终都会调用该函数
    const final = function (status, value) {
        let promise = this, fn, st;

        if (promise._status !== 'PENDING') return;

        // 所以的执行都是异步调用，保证then是先执行的
        setTimeout(() => {
            promise._status = status;
            st = promise._status === 'FULFILLED'
            queue = promise[st ? '_resolves' : '_rejects'];

            while (fn = queue.shift()) {
                value = fn.call(promise, value) || value;
            }

            promise[st ? '_value' : '_reason'] = value;
            promise['_resolves'] = promise['_rejects'] = undefined;
        });
    }


//参数是一个函数，内部提供两个函数作为该函数的参数,分别是resolve 和 reject
    var Promise = function (resolver) {
        if (!(typeof resolver === 'function')) throw new TypeError('You must pass a resolver function as the first argument to the promise constructor');
        //如果不是promise实例，就new一个
        if (!(this instanceof Promise)) return new Promise(resolver);

        const promise = this;
        promise._value;
        promise._reason;
        promise._status = 'PENDING';
        //存储状态
        promise._resolves = [];
        promise._rejects = [];

        //
        const resolve = function (value) {
            //由於apply參數是數組
            final.apply(promise, ['FULFILLED'].concat([value]));
        }

        const reject = function (reason) {
            final.apply(promise, ['REJECTED'].concat([reason]));
        }

        resolver(resolve, reject);
    }

    Promise.prototype.then = function (onFulfilled, onRejected) {
        const promise = this;
        // 每次返回一个promise，保证是可thenable的
        return new Promise(((resolve, reject) => {

            function handle(value) {
                // 這一步很關鍵，只有這樣才可以將值傳遞給下一個resolve
                const ret = typeof onFulfilled === 'function' && onFulfilled(value) || value;

                //判断是不是promise 对象
                if (ret && typeof ret ['then'] === 'function') {
                    ret.then((value) => {
                        resolve(value);
                    }, (reason) => {
                        reject(reason);
                    });
                } else {
                    resolve(ret);
                }
            }

            function errback(reason) {
                reason = typeof onRejected === 'function' && onRejected(reason) || reason;
                reject(reason);
            }

            if (promise._status === 'PENDING') {
                promise._resolves.push(handle);
                promise._rejects.push(errback);
            } else if (promise._status === FULFILLED) { // 状态改变后的then操作，立刻执行
                callback(promise._value);
            } else if (promise._status === REJECTED) {
                errback(promise._reason);
            }
        }));
    }

    Promise.prototype.catch = function (onRejected) {
        return this.then(undefined, onRejected)
    }

    Promise.prototype.delay = function (ms, value) {
        return this.then((ori) => {
            return Promise.delay(ms, value || ori);
        })
    }

    Promise.delay = function (ms, value) {
        return new Promise(((resolve, reject) => {
            setTimeout(() => {
                resolve(value);
                console.log('1');
            }, ms);
        }))
    }

    Promise.resolve = function (arg) {
        return new Promise(((resolve, reject) => {
            resolve(arg)
        }))
    }

    Promise.reject = function (arg) {
        return Promise((resolve, reject) => {
            reject(arg)
        })
    }
    window.Promise = Promise;

})(window);
