import jQuery from 'jquery';

const cssPrefix = 'fuc-';

const Menu = (function ($) {
  $(() => {
    const subMenuContainer = $('.sub-menu-container');
    const rootLayout = $('.fuc-t-fp');
    const mainMenu = $('.main-menu-container');


    /*
     * 处理页面初始化状态
     */
    const activeMenuItem = mainMenu.find('.active');
    //展开默认选中菜单
    activeMenuItem.parents(`.${cssPrefix}menu-item`).addClass('open');
    //滚动到选中位置
    const scroller = activeMenuItem.parents('.menu-wrapper');
    if (activeMenuItem.length > 0 && scroller.height() < activeMenuItem.offset().top) {
      scroller.scrollTop(activeMenuItem.offset().top - scroller.height());
    }

    //处理展开关闭逻辑
    $('.main-menu-container,.sub-menu-container').on('click', `.${cssPrefix}menu-item`, function (e) {
      //最小化菜单走单独的逻辑
      if (rootLayout.hasClass('min-menu')) {
        return;
      }
      const $this = $(this);
      if (!$this.hasClass('open')) {
        $this.parent().find('.open').removeClass('open');
        $this.addClass('open');
      } else {
        $this.removeClass('open');
      }
    });

    //处理子菜单问题
    mainMenu.on('click', `.${cssPrefix}menu .${cssPrefix}menu .${cssPrefix}menu-item`, function (e) {
      const $this = $(this);
      const child = $this.children('ul');
      const level2Head = $this.children('.level2');

      if (level2Head.length > 0) {
        if (child.length > 0) {
          //改变整体布局
          rootLayout.addClass('sub-menu-in');
          //填充子菜单
          subMenuContainer.find('.title').text(level2Head.find('.title').text());
          subMenuContainer.find('.sub-menu-wrapper').html(child[0].outerHTML);

          //移除原有选中状态
          mainMenu.find(`.${cssPrefix}menu-item.active`).removeClass('active');
          //为现有菜单添加选中状态
          $this.addClass('active');
        } else {
          rootLayout.removeClass('sub-menu-in');
        }
      }
    });
    //处理子菜单收回
    subMenuContainer.on('click', '.arrow', (e) => {
      //改变整体布局
      rootLayout.removeClass('sub-menu-in');
    });

    //处理菜单最小化
    $('.menu-controller').on('click', () => {
      rootLayout.toggleClass('min-menu');
    });

    //处理最小菜单第一级菜单的点击事件
    const popupMenu2 = $('.popup-menu');
    $(document.body).on('click', `.${cssPrefix}content,.${cssPrefix}nav,.menu-controller`, () => {
      popupMenu2.css({opacity: 0});
      setTimeout(() => {
        popupMenu2.css({display: 'none'});
      }, 300)
    }).on('click', `.min-menu .main-menu-container .${cssPrefix}menu-item`, function (e) {
      const $this = $(this);
      const subMenu = $this.children(`.${cssPrefix}menu`);
      if (subMenu.length > 0) {
        popupMenu2.children('.title').text($this.children('.menu-title').attr('title'));
        popupMenu2.children('.content').html(subMenu[0].outerHTML);
        popupMenu2.css({top: e.clientY - 40, left: e.clientX, opacity: 0, display: 'block'});
        setTimeout(() => {
          popupMenu2.css({left: 74, opacity: 1});
        }, 30);
      }
    }).on('focus', '.popup-menu .fuc-menu-item .menu-title', (e) => {
      //处理弹出子菜单hover事件

    });
  });

})(jQuery);

export default Menu;
